﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using Demo.Presenter;
using Demo.View;
using Demo.Model;

namespace Demo.Main
{
    internal static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        private static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            AppDomain.CurrentDomain.UnhandledException += CurrentDomain_UnhandledException;

            IMasterView view = new MasterForm();
            MasterPresenter appPresenter = new MasterPresenter(view);

            Application.Run();
        }

        static void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
            Exception ex = (Exception)e.ExceptionObject;
            Debug.WriteLine("Observed unhandled exception: {0}", ex.ToString());
        }
    }
}