using System;
using System.Windows.Forms;
using Demo.Model;
using Demo.Model.Interfaces;
using Demo.View.UserControls;

namespace Demo.Presenter
{
    public class PresenterCipherMaster : IDemoTypePresenter
    {
        protected byte[] Cipher;
        protected readonly CipherMaster CipherPanel;
        protected string CipherText;
        protected readonly FeaturesMaster Features;
        protected readonly IMasterView MasterView;

        public PresenterCipherMaster
            (IMasterView view, CipherMaster cipherPanel, FeaturesMaster features)
        {
            MasterView = view;
            CipherPanel = cipherPanel;
            Features = features;
        }

        public void Activate()
        {
            setCipherPanel();
        }

        protected virtual void EncryptRequested(object sender, EventArgs e)
        {
        }

        private void decryptRequested(object sender, EventArgs e)
        {
        }

        private void plainTextChanged(object sender, EventArgs e)
        {
            CipherPanel.TxtCipherText = string.Empty;
        }

        private void setCipherPanel()
        {
            MasterView.PnlCipher.Controls.Clear();
            MasterView.PnlCipher.Controls.Add(CipherPanel);
            CipherPanel.Dock = DockStyle.Fill;
            MasterView.PnlFeatures.Controls.Clear();
            MasterView.PnlFeatures.Controls.Add(Features);
            Features.EncryptRequested += EncryptRequested;
            Features.DecryptRequested += decryptRequested;
            MasterView.PlainTextChanged += plainTextChanged;
        }
    }
}