using System;
using System.Collections.Generic;
using Demo.Model;
using Demo.View.UserControls;

namespace Demo.Presenter
{
    public class PresenterVariation : PresenterCipherMaster
    {
        private const string PlainTextDefault = "This is an application that communicates securely with a known application."
                                               + "It provides speed and security that can be built into the system that helps a fast, "
                                               + "secure and reliable communication from one machine to another."
                                               +
                                               "It protects data on your system securely with tamper detection built in at the same time.";

        private readonly IList<CipherVariationLog> _variationLog;
        private readonly CipherVariation _cipherPanel;

        public PresenterVariation(IMasterView view, CipherMaster cipherPanel, FeaturesMaster features)
            : base(view, cipherPanel, features)
        {
            _variationLog = new List<CipherVariationLog>();
            _cipherPanel = (CipherVariation) cipherPanel;
            _cipherPanel.CipherVariationCollection = _variationLog;
        }

        protected override void EncryptRequested(object sender, EventArgs e)
        {
            base.EncryptRequested(this, e);
            _variationLog.Add(new CipherVariationLog(PlainTextDefault.Length, PlainTextDefault, DateTime.Now));
            _cipherPanel.CipherVariationCollection = _variationLog;
        }
    }
}