﻿using System;
using System.Collections.Generic;
using Demo.Model;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace Demo.View.UserControls
{
    public partial class CipherVariation : CipherMaster
    {
        private IList<CipherVariationLog> _cipherVariationCollection;

        public CipherVariation()
        {
            InitializeComponent();
            Load += cipherVariationLoad;
        }

        public IList<CipherVariationLog> CipherVariationCollection
        {
            set
            {
                _cipherVariationCollection = value;
                gridCipherVariation.DataSource = null;
                gridCipherVariation.DataSource = _cipherVariationCollection;
            }
        }

        private void cipherVariationLoad(object sender, EventArgs e)
        {
            gridCipherVariation.InitializeLayout += gridCipherVariation_InitializeLayout;
        }

        private static void gridCipherVariation_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.GroupByBox.Hidden = true;
            // STD: Sort grid on column and do not allow sort on child band
            e.Layout.Bands[0].Override.HeaderClickAction = HeaderClickAction.Select;
            // Resize columns to width of grid
            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
            e.Layout.Override.AllowAddNew = AllowAddNew.No;
            e.Layout.Override.AllowDelete = DefaultableBoolean.False;
            e.Layout.Override.AllowUpdate = DefaultableBoolean.False;

            e.Layout.ScrollStyle = ScrollStyle.Immediate;

            // Scrollbars indicates which of the vertical and horizontal scrollbars if any gets shown and how.
            e.Layout.Scrollbars = Scrollbars.Both;

            // Setting ScrollBounds to ScrollToFill will prevent the user from scrolling further down as soon as the last row is fully visible.
            e.Layout.ScrollBounds = ScrollBounds.ScrollToFill;

            // Hide columns
            e.Layout.Bands[0].Columns["TimeStamp"].Hidden = true;

            // Definet column descriptions, widths & appearances
            e.Layout.Bands[0].Columns["CipherLength"].Header.Caption = "Cipher Length";
            e.Layout.Bands[0].Columns["CipherLength"].Width = 27;
            e.Layout.Bands[0].Columns["Description"].Header.Caption = "Description";
            e.Layout.Bands[0].Columns["Description"].Width = 200;
//            e.Layout.Bands[0].Columns["Description"].
            e.Layout.Bands[0].Columns["TimeStamp"].Header.Caption = "Description";

            // Define column positions
            e.Layout.Bands[0].Columns["CipherLength"].Header.VisiblePosition = 0;
            e.Layout.Bands[0].Columns["Description"].Header.VisiblePosition = 1;
            e.Layout.Bands[0].SortedColumns.Add("TimeStamp", true);

            // Pin column
            e.Layout.UseFixedHeaders = true;
            e.Layout.Bands[0].Columns["CipherLength"].Header.Fixed = true;
        }
    }
}